#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stdlib.h>

#define P_PACKAGE PACKAGE
#define P_VERSION VERSION
#define P_REENTRANT _REENTRANT
#undef PACKAGE
#undef VERSION
#undef _REENTRANT

#include "dps_config.h"
#include "dpsearch.h"
#include "dps_indexertool.h"

#undef PACKAGE
#undef VERSION
#undef _REENTRANT
#define PACKAGE P_PACKAGE
#define VERSION P_VERSION
#define _REENTRANT P_REENTRANT

#define DEFAULT_TRACK	DPS_TRACK_DISABLED
#define DEFAULT_MODE	DPS_MODE_ALL
#define DEFAULT_ORD	DPS_ORD_RATE
#define DEFAULT_PS	20
#define DEFAULT_PN	0

#define MAX_QUERY_SIZE  200
#define MAX_PS          100

#define MAX_QUERY_SIZE  200
#define MAX_PS          100
#define MAX_SPELL       128
#define MAX_AFFIX       128

typedef struct tmp_affix_struct {
        char lang[3];
	char *path;
} AFFIX;

typedef struct tmp_spell_struct {
	char lang[3];
	char *path;
} SPELL;

AFFIX Affix[MAX_AFFIX];
SPELL Spell[MAX_SPELL];

int affix_num;
int spell_num;

AV *AVstats;
AV *AVreferers;

/*
 * store results in hash
 */

void dosearch(HV *result,char *query_words,DPS_AGENT *Agent){

  DPS_RESULT *Res=NULL;
  AV *records = newAV();
  size_t first = 0;
  size_t last = 0;
  size_t num_pages = 0, page_size, page_number;
  int is_next=0;
  size_t i, j;

  DpsParseQueryString(Agent, &Agent->Conf->Vars, query_words);
  Agent->Flags = Agent->Conf->Flags;
  /* res */
  if((Res=DpsFind(Agent)) != NULL){

    if(Res->num_rows){

      first = Res->first;
      last = Res->last;
      page_size   = DpsVarListFindInt(&Agent->Conf->Vars, "ps", DEFAULT_PS);
      page_number = DpsVarListFindInt(&Agent->Conf->Vars, "np", 0);

      num_pages = (Res->total_found / (page_size ? page_size : DEFAULT_PS)) + 
	((Res->total_found % (page_size ? page_size : DEFAULT_PS) != 0 ) ?  1 : 0);

      is_next = last < Res->total_found;
      
      for(i = 0; i < Res->num_rows; i++) {
      
	HV* found = newHV();
	DPS_DOCUMENT *Doc = &Res->Doc[i];

	for (j = 0; j < Doc->Sections.nvars; j++) {
	  hv_store(found, Doc->Sections.Var[j].name, strlen(Doc->Sections.Var[j].name),
		   newSVpv(Doc->Sections.Var[j].val, 0), 0);
	}
	
        /* int values */
/*        hv_store(found, "url_id", strlen("url_id"), newSViv(DpsVarListFindInt(&Doc->Sections, "ID", 0)), 0);
        hv_store(found,"status",strlen("status"),newSViv(Res->Doc[i].status),0);
        hv_store(found,"size",strlen("size"),newSViv(Res->Doc[i].size),0);
        hv_store(found,"rating",strlen("rating"),newSViv(Res->Doc[i].rating),0);
        hv_store(found,"order",strlen("order"),newSViv(Res->Doc[i].order),0);
        hv_store(found,"referrer",strlen("referrer"),newSViv(Res->Doc[i].referrer),0);
        hv_store(found,"tag",strlen("tag"),newSViv(Res->Doc[i].tag),0);
        hv_store(found,"hops",strlen("hops"),newSViv(Res->Doc[i].hops),0);
        hv_store(found,"indexed",strlen("indexed"),newSViv(Res->Doc[i].indexed),0);*/
        
	/* char values */
/*        hv_store(found,"url",strlen("url"),newSVpv(Res->Doc[i].url,0),0);
        hv_store(found,"content_type",strlen("content_type"),newSVpv(Res->Doc[i].content_type,0),0);
        hv_store(found,"title",strlen("title"),newSVpv(Res->Doc[i].title,0),0);
        hv_store(found,"keywords",strlen("keywords"),newSVpv(Res->Doc[i].keywords,0),0);
        hv_store(found,"description",strlen("description"),newSVpv(Res->Doc[i].description,0),0);
        hv_store(found,"text",strlen("text"),newSVpv(Res->Doc[i].text,0),0);
        hv_store(found,"category",strlen("category"),newSVpv(Res->Doc[i].category,0),0);*/
  
        /* time_t values */
/*        hv_store(found,"last_mod_time",strlen("last_mod_time"),newSViv(Res->Doc[i].last_mod_time),0);
        hv_store(found,"last_index_time",strlen("last_index_time"),newSViv(Res->Doc[i].last_index_time),0);
        hv_store(found,"next_index_time",strlen("next_index_time"),newSViv(Res->Doc[i].next_index_time),0);*/
    
        /* push record's ref in AV records */
        av_push(records, newRV_inc((SV*) found));
      
      }

    }
    
/*    hv_store(result,"work_time",strlen("work_time"),newSViv(Res->work_time),0);*/

    DpsResultFree(Res);

  } else
      fprintf(stderr, "Error: Dataparksearch : %s", DpsEnvErrMsg(Agent->Conf));


  for (j = 0; j < Agent->Conf->Vars.nvars; j++) {
    hv_store(result, Agent->Conf->Vars.Var[j].name, strlen(Agent->Conf->Vars.Var[j].name),
	     newSVpv(Agent->Conf->Vars.Var[j].val, 0), 0);
  }

  /* insert records's ref in result "records"*/
  hv_store(result,"records",strlen("records"),newRV_inc((SV*) records),0);

  /* insert others SVs */
  hv_store(result,"total_found",strlen("total_found"),newSViv(Res->total_found),0);
  hv_store(result,"page_number",strlen("page_number"),newSViv(page_number),0);
/*  hv_store(result,"word_info",strlen("word_info"),newSVpv(Agent->wordinfo,0),0);*/

  hv_store(result,"num_pages",strlen("num_pages"),newSViv(num_pages),0);
  hv_store(result,"is_next",strlen("is_next"),newSViv(is_next),0);
  hv_store(result,"first",strlen("first"),newSViv(first),0);
  hv_store(result,"last",strlen("last"),newSViv(last),0);

}

/* 
 * CallBack Func for Referers
 */

static void DpsRefProc(int code, const char *url, const char * ref){
  AV *records = newAV();
  SV *SVcode;
  SV *SVurl;
  SV *SVref;

  SVcode = newSViv(code);
  SVurl  = newSVpv((char*)url,0);
  SVref  = newSVpv((char*)ref,0);

  av_push(records, SVcode);
  av_push(records, SVurl);
  av_push(records, SVref);

  av_push(AVreferers, newRV_inc((SV*) records));

}

static int GetReferers(DPS_AGENT * Indexer){
  int res;
  AVreferers = newAV();
  printf("\n          URLs and referers \n\n");
  res = DpsURLAction(Indexer, NULL, DPS_URL_ACTION_REFERERS);
  return(res);
}

/* 
 * CallBack Func for Stats
 */

static void DpsStatProc(int handle, int code, int expired, int total, const char* str){
  AV *records = newAV();
  SV *SVcode;
  SV *SVexpired;
  SV *SVtotal;
  SV *SVstr;

  SVcode = newSViv(code);
  SVexpired = newSViv(expired);
  SVtotal = newSViv(total);
  SVstr = newSVpv((char*)str,0);

  av_push(records, SVcode);
  av_push(records, SVexpired);
  av_push(records, SVtotal);
  av_push(records, SVstr);

  av_push(AVstats, newRV_inc((SV*) records));

}

/* */

static int GetStatistics(DPS_AGENT * Indexer){
  int res;
  AVstats = newAV();
  res=DpsShowStatistics(Indexer);
  return(res);
}


/*
 * Assign Hashs values into DPS_AGENT
 */

void assign_hash(DPS_AGENT *Agent,char *name, SV *value ){

  SV* itervalue;
  HV* hash = (HV*)SvRV((SV*)value);
  HE* hashentry;
  STRLEN n_a;
  char *location;
  char *lang;
  char str[PATH_MAX]="";

  if (!strncasecmp(name,"Affix", 5)){
    hv_iterinit(hash);
    while ((hashentry=hv_iternext(hash)) != NULL){

      itervalue = hv_iterval(hash,hashentry);
      if ( SvTYPE(itervalue) !=SVt_PV ) croak("Usage: Dataparksearch::_DpsQuery('Affix'=>{lang => location,...},...)");
      lang = (char *)SvPV(hv_iterkeysv(hashentry), n_a);
      location = (char *)SvPV(itervalue, n_a);

      if (affix_num < MAX_AFFIX){

        if (*location=='/') strcpy(str,location);
        else sprintf(str,"%s/%s",DPS_CONF_DIR,location);

        strncpy(Affix[(int)affix_num].lang,lang,2);
        Affix[(int)affix_num].lang[2]=0;
        Affix[(int)affix_num].path=strdup(str);
        affix_num++;
      } else {
        fprintf(stderr,"Warning: Dataparksearch MAX_AFFIX reached, skipping %s - %s\n",lang,location);
      }
    }
    return;
  }

  if (!strncasecmp(name,"Spell", 5)) {
    hv_iterinit(hash);
    while ((hashentry=hv_iternext(hash)) != NULL){

      itervalue = hv_iterval(hash,hashentry);
      if ( SvTYPE(itervalue) !=SVt_PV ) croak("Usage: Dataparksearch::_DpsQuery('Spell'=>{lang => location,...},...)");
      lang = (char *)SvPV(hv_iterkeysv(hashentry), n_a);
      location = (char *)SvPV(itervalue, n_a);

      if (spell_num < MAX_SPELL){

        if (*location=='/') strcpy(str,location);
        else sprintf(str,"%s/%s",DPS_CONF_DIR,location);

        strncpy(Spell[(int)spell_num].lang,lang,2);
        Spell[(int)spell_num].lang[2]=0;
        Spell[(int)spell_num].path=strdup(str);
        spell_num++;
      } else {
        fprintf(stderr,"Warning: Dataparksearch MAX_SPELL reached, skipping %s - %s\n",lang,location);
      }
    }
    return;
  }

  fprintf(stderr,"Warning: Dataparksearch hash argument %s not supported\n",name);

}

/*
 *
 *
 *
 */

void InitAgent(SV *self,DPS_AGENT *Agent){
  HE* hashentry;
  char * value;
  STRLEN n_a;
  HV* hash = (HV*)SvRV((SV*)self);

  affix_num=0;
  spell_num=0;

  /* inits with defaults */
  Agent->search_mode=DEFAULT_MODE;
  Agent->sort_order=DEFAULT_ORD;
  Agent->page_number=DEFAULT_PN;
  Agent->page_size=DEFAULT_PS;
  Agent->track_mode=DEFAULT_TRACK;

  /* Check for TrackQuery */
  if ( hv_exists(hash,"TrackQuery",strlen("TrackQuery"))){
    hashentry = hv_fetch_ent(hash,newSVpv("TrackQuery",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    switch(*value){
      case '0' :
        Agent->track_mode=DPS_TRACK_DISABLED;
      case '1' :
        Agent->track_mode=DPS_TRACK_QUERIES;
      default :
        Agent->track_mode=DPS_TRACK_DISABLED;
    }
  }
  
  /* Check for mode */
   if ( hv_exists(hash,"mode",strlen("mode"))){
    hashentry = hv_fetch_ent(hash,newSVpv("mode",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    if (!DPS_STRNCASECMP(value,"all")) Agent->search_mode=DPS_MODE_ALL;
    else if (!DPS_STRNCASECMP(value,"any")) Agent->search_mode=DPS_MODE_ANY;
    else if (!DPS_STRNCASECMP(value,"bool")) Agent->search_mode=DPS_MODE_BOOL;
    else if (!DPS_STRNCASECMP(value,"phrase")) {
      Agent->search_mode=DPS_MODE_PHRASE; 
      Agent->Conf->use_phrases=1; /* FIXME : Dont use 'Phrase yes' from search.c*/
    } else {
      Agent->Conf->use_phrases=0;
    }
  }
 
  /* Check for sort */
  if ( hv_exists(hash,"sort",strlen("sort"))){
    hashentry = hv_fetch_ent(hash,newSVpv("sort",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    if (!DPS_STRNCASECMP(value,"rate"))
      Agent->sort_order=DPS_ORD_RATE;
    else if (!DPS_STRNCASECMP(value,"date"))
      Agent->sort_order=DPS_ORD_DATE;
  }

  /* Check for pn */
  if ( hv_exists(hash,"pn",strlen("pn"))){
    char *lastcar;
    int pn = 0;
    hashentry = hv_fetch_ent(hash,newSVpv("pn",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    pn = strtol(value,&lastcar,10);
    if(*lastcar != '\0') pn = 0; 
    if(pn < 0) pn=0;
    Agent->page_number = pn;
  }
  
  /* Check for ps */
  if ( hv_exists(hash,"ps",strlen("ps"))){
    char *lastcar;
    int ps = 0;
    hashentry = hv_fetch_ent(hash,newSVpv("ps",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    ps = strtol(value,&lastcar,10);
    if(*lastcar != '\0') ps = DEFAULT_PS;
    if(ps < 0) ps=DEFAULT_PS;
    Agent->page_size=ps>MAX_PS?MAX_PS:ps?ps:DEFAULT_PS;
  }
  
  /* Check for LocalCharset */
  if ( hv_exists(hash,"LocalCharset",strlen("LocalCharset"))){
    hashentry = hv_fetch_ent(hash,newSVpv("LocalCharset",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    Agent->Conf->local_charset=DpsGetCharset(value);
    Agent->charset=Agent->Conf->local_charset;
  }
  
  /* Check for ul */
  if ( hv_exists(hash,"ul",strlen("ul"))){
    char str1[DPSSTRSIZ+1]="";
    hashentry = hv_fetch_ent(hash,newSVpv("ul",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    snprintf(str1,DPSSTRSIZ,"%%%s%%",value);
    DpsAddURLLimit(Agent->Conf,str1);
  }
  
  /* Check for Weight Factor wf */
  if ( hv_exists(hash,"wf",strlen("wf"))){
    char str1[DPSSTRSIZ+1]="";
    hashentry = hv_fetch_ent(hash,newSVpv("wf",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    Agent->weight_factor=value;
  }
  
  /* Check for Word Match wm */
  if ( hv_exists(hash,"wm",strlen("wm"))){
    char str1[DPSSTRSIZ+1]="";
    hashentry = hv_fetch_ent(hash,newSVpv("wm",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    if(!strcmp(value,"wrd"))Agent->word_match=DPS_MATCH_WORD;
    else if(!strcmp(value,"beg"))Agent->word_match=DPS_MATCH_BEGIN;
    else if(!strcmp(value,"end"))Agent->word_match=DPS_MATCH_END; 
    else if(!strcmp(value,"sub"))Agent->word_match=DPS_MATCH_SUBSTR;
  }
  
  /* Check for IspellMode */
  if ( hv_exists(hash,"IspellMode",strlen("IspellMode"))){
    hashentry = hv_fetch_ent(hash,newSVpv("IspellMode",0), 0, 0);
    value = (char *)SvPV(HeVAL(hashentry), n_a);
    if (!DPS_STRNCASECMP(value,"db"))
      Agent->Conf->ispell_mode|=DPS_ISPELL_MODE_DB;
    else
      Agent->Conf->ispell_mode &= ~DPS_ISPELL_MODE_DB;
  }

  /* check Affix & Spell only if not IspellMode db */
  if(!(Agent->Conf->ispell_mode&DPS_ISPELL_MODE_DB)){
    
    /* Check for Affix */
    if ( hv_exists(hash,"Affix",strlen("Affix"))){
      hashentry = hv_fetch_ent(hash,newSVpv("Affix",0), 0, 0);
      assign_hash(Agent,"Affix",(SV*)HeVAL(hashentry));
    }
    
    /* Check for Spell*/
    if ( hv_exists(hash,"Spell",strlen("Spell"))){
      hashentry = hv_fetch_ent(hash,newSVpv("Spell",0), 0, 0);
      assign_hash(Agent,"Spell",(SV*)HeVAL(hashentry));
    }

  }

  return;

}


/*
 * Return an DPS_ENV initialized with 
 * $self->{'DBAddr'} & $self->{'DBMode'}
 *
 */

DPS_ENV * LoadConf(SV *self){

  DPS_ENV *Conf=NULL;
  HV* hash = (HV*)SvRV((SV*)self);
  HE* hashentry;
  STRLEN n_a;
  char * DBAddr;
  char * DBMode;

  Conf=DpsAllocEnv();

  /* define callback funcs */
  DpsSetStatProc(Conf,DpsStatProc);
  DpsSetRefProc(Conf,DpsRefProc);
  
  if (! hv_exists(hash,"DBAddr",strlen("DBAddr")))
    croak("Error: Dataparksearch need a DBAddr");
  
  hashentry = hv_fetch_ent(hash,newSVpv("DBAddr",0), 0, 0);
  DBAddr = (char *)SvPV(HeVAL(hashentry), n_a);

  hashentry = hv_fetch_ent(hash,newSVpv("DBMode",0), 0, 0);
  DBMode = (char *)SvPV(HeVAL(hashentry), n_a);

  Conf->errcode=0;
  Conf->errstr[0]=0;
  Conf->force1251=0;
  Conf->nspell=0;
  Conf->extra_headers[0]=0;
  Conf->max_doc_size=DPS_MAXDOCSIZE;
  Conf->local_charset=DPS_CHARSET_USASCII;

  DpsEnvSetDBAddr(Conf, DBAddr);
  DpsEnvSetDBMode(Conf, DBMode);

  return(Conf);

}

/*
 * Perl interface
 *
 */

MODULE = Dataparksearch		PACKAGE = Dataparksearch

int
DpsVersion()
	PPCODE:
	 EXTEND(SP, 1);
	 PUSHs(newSVpv((char*)DpsVersion(),0));

void
GetStatistics( ... )
        PREINIT:
         DPS_AGENT *Agent=NULL;
         DPS_ENV *Conf=NULL;
	 SV *self=NULL;
        PPCODE:
	 self = ST(0);
         DpsInit();
	 Conf=LoadConf(self);
         Agent=DpsAllocAgent(Conf, 0, DPS_OPEN_MODE_READ);
	 if(GetStatistics(Agent)!=IND_OK){
	   DpsLog(Agent,DPS_LOG_ERROR,"Error: '%s'",DpsAgentErrorMsg(Agent));
	 }
	 DpsFreeAgent(Agent);
 	 DpsFreeEnv(Conf);
	 EXTEND(SP,1);
	 PUSHs(newRV_inc((SV*) AVstats));

void
GetReferers( ... )
        PREINIT:
         DPS_AGENT *Agent=NULL;
         DPS_ENV *Conf=NULL;
         SV *self=NULL;
        PPCODE:
         self = ST(0);
         DpsInit();
         Conf=LoadConf(self);
         Agent=DpsAllocAgent(Conf, 0, DPS_OPEN_MODE_READ);
         if(GetReferers(Agent)!=IND_OK){
	   DpsLog(Agent,DPS_LOG_ERROR,"Error: '%s'",DpsAgentErrorMsg(Agent));
         }
         DpsFreeAgent(Agent);
         DpsFreeEnv(Conf);
         EXTEND(SP,1);
         PUSHs(newRV_inc((SV*) AVreferers));

int
DpsGetDocCount(...)
        PREINIT:
         DPS_AGENT *Agent=NULL;
         DPS_ENV *Conf=NULL;
         SV *self=NULL;
	 int count=0;
        PPCODE:
         self = ST(0);
         DpsInit();
         Conf=LoadConf(self);
         Agent=DpsAllocAgent(Conf, 0, DPS_OPEN_MODE_READ);
	 count=DpsGetDocCount(Agent);
         DpsFreeAgent(Agent);
         DpsFreeEnv(Conf);
         EXTEND(SP,1);
         PUSHs(newSViv(count));

int
_DpsQuery( ... )
	PREINIT:
	 DPS_AGENT *Agent=NULL;
	 DPS_ENV *Conf=NULL;
	 HV *result=newHV();
	 SV *self=NULL;
	 int i;
	 char *query;
  	 char words[MAX_QUERY_SIZE + 1];
	 STRLEN n_a;
	PPCODE:
	 words[0] = '\0';

	 if (items != 2) 
	   croak("Usage: Dataparksearch $self->_DpsQuery(\"words\")"); 

	 self = ST(0);
 
	 DpsInit();
	 Conf=LoadConf(self);
	 Agent=DpsAllocAgent(Conf, 0, DPS_OPEN_MODE_READ);
	 InitAgent(self,Agent);


	 /* read query words */
	 query = (char *)SvPV(ST(1),n_a);
         strncpy(words,query,MAX_QUERY_SIZE);
         if (! strcmp(words,"")) 
	   croak("Error: Dataparksearch Need a query argument");

         words[MAX_QUERY_SIZE] = '\0';

	 DpsTolower(words,Agent->charset);

         if(!(Agent->Conf->ispell_mode&DPS_ISPELL_MODE_DB)){
           char first_letters[128]="";
           char str[BUFSIZ];
           char *w, *lasttok;

           strcpy(str,words);
           w=DpsGetWord(str,&lasttok,Agent->charset);

           while(w){
             int len=strlen(first_letters);
             first_letters[len]=w[0];
             first_letters[len+1]=0;
             w=DpsGetWord(NULL,&lasttok,Agent->charset);
           }

           for(i=0;i<spell_num;i++)
             DpsImportDictionary(Agent->Conf,Spell[i].lang,Spell[i].path,1,first_letters);

           for(i=0;i<affix_num;i++)
             DpsImportAffixes(Agent->Conf,Affix[i].lang,Affix[i].path,NULL,0); 

           if(spell_num)DpsSortDictionary(Agent->Conf);

           DpsSortAffixes(Agent->Conf);

         }

         if (Agent->Conf->ispell_mode&DPS_ISPELL_MODE_DB) {
           if (DpsDBImportAffixes(Agent,Agent->charset)) {
            //TODO : return an error code & exit.
           }
         }

	 dosearch(result,words,Agent);
         
	 for(i=0;i<affix_num;i++) free(Affix[i].path);
	 for(i=0;i<spell_num;i++) free(Spell[i].path);
	 
	 DpsFreeEnv(Conf);
	 DpsFreeAgent(Agent); 
	      
	 EXTEND(SP,1);
	 PUSHs(newRV_inc((SV*) result));
